(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("ReactDOMServer"), require("react-redux"), require("nprogress"));
	else if(typeof define === 'function' && define.amd)
		define(["react", "ReactDOMServer", "react-redux", "nprogress"], factory);
	else if(typeof exports === 'object')
		exports["ReduxNprogress"] = factory(require("react"), require("ReactDOMServer"), require("react-redux"), require("nprogress"));
	else
		root["ReduxNprogress"] = factory(root["react"], root["ReactDOMServer"], root["react-redux"], root["nprogress"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_7__, __WEBPACK_EXTERNAL_MODULE_8__, __WEBPACK_EXTERNAL_MODULE_9__, __WEBPACK_EXTERNAL_MODULE_10__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.endTask = exports.beginTask = exports.NProgress = exports.nprogress = exports.nprogressMiddleware = undefined;

	var _middleware = __webpack_require__(1);

	var _middleware2 = _interopRequireDefault(_middleware);

	var _reducer = __webpack_require__(5);

	var _reducer2 = _interopRequireDefault(_reducer);

	var _NProgressComponent = __webpack_require__(6);

	var _NProgressComponent2 = _interopRequireDefault(_NProgressComponent);

	var _actions = __webpack_require__(3);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	exports.nprogressMiddleware = _middleware2.default;
	exports.nprogress = _reducer2.default;
	exports.NProgress = _NProgressComponent2.default;
	exports.beginTask = _actions.beginTask;
	exports.endTask = _actions.endTask;

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _constants = __webpack_require__(2);

	var ActionTypes = _interopRequireWildcard(_constants);

	var _actions = __webpack_require__(3);

	var _isArray = __webpack_require__(4);

	var _isArray2 = _interopRequireDefault(_isArray);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

	var nprogressMetaKey = '__nprogress__';

	var resultActionTypeSuffixes = ['FULFILLED', 'REJECTED'];

	var isNProgressResultAction = function isNProgressResultAction(type, fulfilled, rejected) {
	  return type === fulfilled || type === rejected;
	};

	var getNProgressMeta = function getNProgressMeta(type, nprogress, configSuffixes) {
	  if ((0, _isArray2.default)(nprogress)) {
	    return nprogress;
	  }

	  var suffixes = nprogress.resultActionTypeSuffixes || configSuffixes;

	  return suffixes.map(function (suffix) {
	    return type + '_' + suffix;
	  });
	};

	var isNProgressMetaAction = function isNProgressMetaAction(_ref) {
	  var type = _ref.type;
	  var meta = _ref.meta;

	  return meta && meta[nprogressMetaKey] && isNProgressResultAction.apply(undefined, [type].concat(_toConsumableArray(meta[nprogressMetaKey])));
	};

	var isNProgressAction = function isNProgressAction(_ref2) {
	  var nprogress = _ref2.nprogress;

	  var rest = _objectWithoutProperties(_ref2, ['nprogress']);

	  return nprogress || isNProgressMetaAction(rest);
	};

	exports.default = function () {
	  var config = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

	  var suffixes = config.resultActionTypeSuffixes || resultActionTypeSuffixes;

	  return function (_ref3) {
	    var dispatch = _ref3.dispatch;
	    return function (next) {
	      return function (action) {
	        var type = action.type;
	        var meta = action.meta;


	        if (!isNProgressAction(action)) {
	          return next(action);
	        }

	        if (action.nprogress) {
	          var nprogress = action.nprogress;

	          var actionProps = _objectWithoutProperties(action, ['nprogress']);

	          dispatch((0, _actions.beginTask)());

	          return next(_extends({}, actionProps, {
	            meta: _extends({}, meta, _defineProperty({}, nprogressMetaKey, getNProgressMeta(type, nprogress, suffixes)))
	          }));
	        }

	        if (isNProgressMetaAction(action)) {
	          var _action$meta = action.meta;
	          var __nprogress__ = _action$meta.__nprogress__;

	          var metaProps = _objectWithoutProperties(_action$meta, ['__nprogress__']);

	          var _actionProps = _objectWithoutProperties(action, ['meta']);

	          var hasMeta = Object.keys(metaProps).length > 0;

	          dispatch((0, _actions.endTask)());

	          return next(_extends({}, _actionProps, hasMeta ? { meta: metaProps } : {}));
	        }
	      };
	    };
	  };
	};

/***/ },
/* 2 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var BEGIN_TASK = exports.BEGIN_TASK = '@@redux-nprogress/BEGIN_TASK';
	var END_TASK = exports.END_TASK = '@@redux-nprogress/END_TASK';

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.beginTask = beginTask;
	exports.endTask = endTask;

	var _constants = __webpack_require__(2);

	var ActionTypes = _interopRequireWildcard(_constants);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	function beginTask() {
	  return {
	    type: ActionTypes.BEGIN_TASK
	  };
	}

	function endTask() {
	  return {
	    type: ActionTypes.END_TASK
	  };
	}

/***/ },
/* 4 */
/***/ function(module, exports) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	exports.default = function (value) {
	  return value && value.length >= 0 && Object.prototype.toString.call(value) === '[object Array]';
	};

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _constants = __webpack_require__(2);

	var ActionTypes = _interopRequireWildcard(_constants);

	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

	var initialState = {
	  tasks: 0
	};

	exports.default = function () {
	  var state = arguments.length <= 0 || arguments[0] === undefined ? initialState : arguments[0];
	  var action = arguments[1];

	  switch (action.type) {
	    case ActionTypes.BEGIN_TASK:
	      return {
	        tasks: state.tasks + 1
	      };

	    case ActionTypes.END_TASK:
	      return {
	        tasks: state.tasks - 1
	      };

	    default:
	      return state;
	  }
	};

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(7);

	var _react2 = _interopRequireDefault(_react);

	var _server = __webpack_require__(8);

	var _reactRedux = __webpack_require__(9);

	var _nprogress = __webpack_require__(10);

	var _nprogress2 = _interopRequireDefault(_nprogress);

	var _NProgressTemplate = __webpack_require__(11);

	var _NProgressTemplate2 = _interopRequireDefault(_NProgressTemplate);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	var NProgressComponent = function (_Component) {
	  _inherits(NProgressComponent, _Component);

	  function NProgressComponent() {
	    _classCallCheck(this, NProgressComponent);

	    return _possibleConstructorReturn(this, (NProgressComponent.__proto__ || Object.getPrototypeOf(NProgressComponent)).apply(this, arguments));
	  }

	  _createClass(NProgressComponent, [{
	    key: 'componentWillMount',
	    value: function componentWillMount() {
	      var _props = this.props;
	      var nprogress = _props.nprogress;

	      var rest = _objectWithoutProperties(_props, ['nprogress']);

	      var template = (0, _server.renderToString)(_react2.default.createElement(_NProgressTemplate2.default, rest));

	      _nprogress2.default.configure(_extends({}, nprogress, { template: template
	      }));
	    }
	  }, {
	    key: 'componentWillUnmount',
	    value: function componentWillUnmount() {
	      _nprogress2.default.remove();
	    }
	  }, {
	    key: 'componentWillReceiveProps',
	    value: function componentWillReceiveProps(nextProps) {
	      var tasks = nextProps.tasks;


	      if (tasks === 0) {
	        _nprogress2.default.done();
	      } else {
	        _nprogress2.default.inc();
	      }
	    }
	  }, {
	    key: 'render',
	    value: function render() {
	      return null;
	    }
	  }]);

	  return NProgressComponent;
	}(_react.Component);

	NProgressComponent.propTypes = {
	  nprogress: _react.PropTypes.object
	};


	function mapStateToProps(state, _ref) {
	  var nprogressKey = _ref.nprogressKey;

	  return state[nprogressKey || 'nprogress'];
	}

	exports.default = (0, _reactRedux.connect)(mapStateToProps, null)(NProgressComponent);

/***/ },
/* 7 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_7__;

/***/ },
/* 8 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_8__;

/***/ },
/* 9 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_9__;

/***/ },
/* 10 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_10__;

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	var _react = __webpack_require__(7);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

	/* TODO.

	  <div class="spinner" role="spinner">
	    <div class="spinner-icon"></div>
	  </div>

	*/

	var barStyles = {
	  position: 'fixed',
	  zIndex: 1031,
	  top: 0,
	  left: 0,
	  width: '100%',
	  height: '2px'
	};

	var pegStyles = {
	  display: 'block',
	  position: 'absolute',
	  right: '0px',
	  width: '100px',
	  height: '100%',
	  opacity: 1.0,
	  WebkitTransform: 'rotate(3deg) translate(0px, -4px)',
	  msTransform: 'rotate(3deg) translate(0px, -4px)',
	  transform: 'rotate(3deg) translate(0px, -4px)'
	};

	var NProgressTemplate = function (_Component) {
	  _inherits(NProgressTemplate, _Component);

	  function NProgressTemplate() {
	    _classCallCheck(this, NProgressTemplate);

	    return _possibleConstructorReturn(this, (NProgressTemplate.__proto__ || Object.getPrototypeOf(NProgressTemplate)).apply(this, arguments));
	  }

	  _createClass(NProgressTemplate, [{
	    key: 'render',
	    value: function render() {
	      var color = this.props.color;


	      return _react2.default.createElement(
	        'div',
	        { className: 'bar',
	          role: 'bar',
	          style: _extends({}, barStyles, { background: color }) },
	        _react2.default.createElement('div', { className: 'peg',
	          style: _extends({}, pegStyles, { boxShadow: '0 0 10px ' + color + ', 0 0 5px ' + color }) })
	      );
	    }
	  }]);

	  return NProgressTemplate;
	}(_react.Component);

	NProgressTemplate.propTypes = {
	  color: _react.PropTypes.string
	};
	NProgressTemplate.defaultProps = {
	  color: '#29d'
	};
	exports.default = NProgressTemplate;

/***/ }
/******/ ])
});
;